/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */

import { Dictionary } from "../models/Dictionary";

type FieldDefinition = {
    readonly type?: string;
    readonly isReadOnly?: boolean;
    readonly isRequired?: boolean;
    readonly isNullable?: boolean;
    readonly format?: string;
    readonly maximum?: number;
    readonly exclusiveMaximum?: boolean;
    readonly minimum?: number;
    readonly exclusiveMinimum?: boolean;
    readonly multipleOf?: number;
    readonly maxLength?: number;
    readonly minLength?: number;
    readonly pattern?: string;
    readonly maxItems?: number;
    readonly minItems?: number;
    readonly uniqueItems?: boolean;
    readonly maxProperties?: number;
    readonly minProperties?: number;
}

export type Definition<T> =
    T extends string ? FieldDefinition :
    T extends number ? FieldDefinition :
    T extends boolean ? FieldDefinition :
    T extends File ? FieldDefinition :
    T extends Blob ? FieldDefinition :
    T extends Array<infer U> ? FieldDefinition :
    T extends Dictionary<infer U> ? FieldDefinition :
    T extends Object ? FieldDefinition & {
        readonly [K in keyof T]: Definition<T[K]>;
    } : FieldDefinition
